
#include <windows.h>
#include <commctrl.h>
#include "../../../plugin.h"
#include "resource.h"

#define WM_COMBO_REFRESH	(WM_APP + 109)
#define WM_KEYBOARD_MSG		(WM_APP + 110)
#define HOTKEYF_WIN			0x10

BOOL Init(void);
void Quit(void);
void Config(PREFS* prefs, CONFIGPARAM* configparam);
void Command(COMMANDPARAM* param);
void Description(COMMANDARGV* argv, LPWSTR lpszText, int nLength);

PLUGIN plugin = {
	PLUGIN_VERSION,
	0,
	L"L[𑗂",
	NULL,
	NULL,
	Init,
	Quit,
	Config,
	Command,
	Description
};

HWND hDlg = NULL;
HHOOK hHook = NULL;

EXTERN_C PLUGIN * WINAPI GetPlugin(void)
{
	return &plugin;
}

void get_keyname(const LONG SendKey, LPTSTR lpszKeyName, int nSize)
{
	TCHAR szKeyName[1024] = TEXT("");
	UINT modifiers = ((HIBYTE(SendKey) & HOTKEYF_SHIFT) ? MOD_SHIFT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_CONTROL) ? MOD_CONTROL : 0) |
		((HIBYTE(SendKey) & HOTKEYF_ALT) ? MOD_ALT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_WIN) ? MOD_WIN : 0);
	UINT virtkey = LOBYTE(SendKey);
	UINT scan_code;
	int ext_flag = 0;

	if(modifiers & MOD_CONTROL)
		lstrcat(szKeyName, TEXT("Ctrl + "));
	if(modifiers & MOD_SHIFT)
		lstrcat(szKeyName, TEXT("Shift + "));
	if(modifiers & MOD_ALT)
		lstrcat(szKeyName, TEXT("Alt + "));
	if(modifiers & MOD_WIN)
		lstrcat(szKeyName, TEXT("Win + "));

	switch(virtkey)
	{
	case VK_LBUTTON:
		lstrcat(szKeyName, TEXT("Left mouse button"));
		break;
	case VK_RBUTTON:
		lstrcat(szKeyName, TEXT("Right mouse button"));
		break;
	case VK_MBUTTON:
		lstrcat(szKeyName, TEXT("Middle mouse button"));
		break;
	case VK_XBUTTON1:
		lstrcat(szKeyName, TEXT("X1 mouse button"));
		break;
	case VK_XBUTTON2:
		lstrcat(szKeyName, TEXT("X2 mouse button"));
		break;
	case VK_PAUSE:
		lstrcat(szKeyName, TEXT("Pause"));
		break;
	case VK_CAPITAL:
		lstrcat(szKeyName, TEXT("Caps Lock"));
		break;
	case VK_KANJI:
		lstrcat(szKeyName, TEXT("IME On/Off"));
		break;
	case VK_SNAPSHOT:
		lstrcat(szKeyName, TEXT("Print Screen"));
		break;
	case VK_LWIN:
		lstrcat(szKeyName, TEXT("Win"));
		break;
	case VK_SEPARATOR:
		lstrcat(szKeyName, TEXT("Num Enter"));
		break;
	case 0x5F:
		lstrcat(szKeyName, TEXT("Computer Sleep"));
		break;
	case VK_DECIMAL:
		lstrcat(szKeyName, TEXT("Num ."));
		break;
	case 0xA6:
		lstrcat(szKeyName, TEXT("Browser Back"));
		break;
	case 0xA7:
		lstrcat(szKeyName, TEXT("Browser Forward"));
		break;
	case 0xA8:
		lstrcat(szKeyName, TEXT("Browser Refresh"));
		break;
	case 0xA9:
		lstrcat(szKeyName, TEXT("Browser Stop"));
		break;
	case 0xAA:
		lstrcat(szKeyName, TEXT("Browser Search"));
		break;
	case 0xAB:
		lstrcat(szKeyName, TEXT("Browser Favorites"));
		break;
	case 0xAC:
		lstrcat(szKeyName, TEXT("Browser Start and Home"));
		break;
	case 0xAD:
		lstrcat(szKeyName, TEXT("Volume Mute"));
		break;
	case 0xAE:
		lstrcat(szKeyName, TEXT("Volume Down"));
		break;
	case 0xAF:
		lstrcat(szKeyName, TEXT("Volume Up"));
		break;
	case 0xB0:
		lstrcat(szKeyName, TEXT("Next Track"));
		break;
	case 0xB1:
		lstrcat(szKeyName, TEXT("Previous Track"));
		break;
	case 0xB2:
		lstrcat(szKeyName, TEXT("Stop Media"));
		break;
	case 0xB3:
		lstrcat(szKeyName, TEXT("Play/Pause Media"));
		break;
	case 0xB4:
		lstrcat(szKeyName, TEXT("Start Mail"));
		break;
	case 0xB5:
		lstrcat(szKeyName, TEXT("Select Media"));
		break;
	case 0xB6:
		lstrcat(szKeyName, TEXT("Start Application 1"));
		break;
	case 0xB7:
		lstrcat(szKeyName, TEXT("Start Application 2"));
		break;
	default:
		scan_code = MapVirtualKey(virtkey, 0);
		if(virtkey == VK_CANCEL ||
			virtkey == VK_DIVIDE ||
			virtkey == VK_APPS ||
			virtkey == VK_PRIOR ||
			virtkey == VK_NEXT ||
			virtkey == VK_END ||
			virtkey == VK_HOME ||
			virtkey == VK_LEFT ||
			virtkey == VK_UP ||
			virtkey == VK_RIGHT ||
			virtkey == VK_DOWN ||
			virtkey == VK_INSERT ||
			virtkey == VK_DELETE ||
			virtkey == VK_NUMLOCK) ext_flag = 1 << 24;
		GetKeyNameText((scan_code << 16) | ext_flag, szKeyName + lstrlen(szKeyName), 1024-lstrlen(szKeyName));
		break;
	}
	lstrcpyn(lpszKeyName, szKeyName, nSize);
}

void ExecuteSendKey(int Case, LONG SendKey, int ClickWait)
{
	UINT modifiers = ((HIBYTE(SendKey) & HOTKEYF_SHIFT) ? MOD_SHIFT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_CONTROL) ? MOD_CONTROL : 0) |
		((HIBYTE(SendKey) & HOTKEYF_ALT) ? MOD_ALT : 0) |
		((HIBYTE(SendKey) & HOTKEYF_WIN) ? MOD_WIN : 0);
	UINT virtkey = LOBYTE(SendKey);
	UINT Extend = 0;

	switch(virtkey)
	{
	case VK_INSERT:
	case VK_DELETE:
	case VK_HOME:
	case VK_END:
	case VK_PRIOR:
	case VK_NEXT:
	case VK_LEFT:
	case VK_UP:
	case VK_RIGHT:
	case VK_DOWN:
	case VK_NUMLOCK:
	case VK_CANCEL:
	case VK_SNAPSHOT:
	case VK_SEPARATOR:
	case VK_DIVIDE:
		Extend = KEYEVENTF_EXTENDEDKEY;
		break;
	}

	if(Case == 0 || Case == 1)
	{
		//gݍ킹L[
		if(modifiers & MOD_SHIFT)
			keybd_event(VK_SHIFT, (BYTE)MapVirtualKey(VK_SHIFT, 0), 0, 0);
		if(modifiers & MOD_CONTROL)
			keybd_event(VK_CONTROL, (BYTE)MapVirtualKey(VK_CONTROL, 0), 0, 0);
		if(modifiers & MOD_ALT)
			keybd_event(VK_MENU, (BYTE)MapVirtualKey(VK_MENU, 0), 0, 0);
		if(modifiers & MOD_WIN)
			keybd_event(VK_LWIN, (BYTE)MapVirtualKey(VK_LWIN, 0), 0, 0);

		switch(virtkey)
		{
		case VK_LBUTTON:
			mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
			break;
		case VK_RBUTTON:
			mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
			break;
		case VK_MBUTTON:
			mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0, 0, 0, 0);
			break;
		case VK_XBUTTON1:
			mouse_event(MOUSEEVENTF_XDOWN, 0, 0, XBUTTON1, 0);
			break;
		case VK_XBUTTON2:
			mouse_event(MOUSEEVENTF_XDOWN, 0, 0, XBUTTON2, 0);
			break;
		default:
			keybd_event((BYTE)virtkey, (BYTE)MapVirtualKey(virtkey, 0), Extend, 0);
			break;
		}
		Sleep(ClickWait);
	}

	if(Case == 0 || Case == 2)
	{
		switch(virtkey)
		{
		case VK_LBUTTON:
			mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
			break;
		case VK_RBUTTON:
			mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
			break;
		case VK_MBUTTON:
			mouse_event(MOUSEEVENTF_MIDDLEUP, 0, 0, 0, 0);
			break;
		case VK_XBUTTON1:
			mouse_event(MOUSEEVENTF_XUP, 0, 0, XBUTTON1, 0);
			break;
		case VK_XBUTTON2:
			mouse_event(MOUSEEVENTF_XUP, 0, 0, XBUTTON2, 0);
			break;
		default:
			keybd_event((BYTE)virtkey, (BYTE)MapVirtualKey(virtkey, 0), Extend | KEYEVENTF_KEYUP, 0);
			break;
		}

		//gݍ킹L[
		if(modifiers & MOD_WIN)
			keybd_event(VK_LWIN, (BYTE)MapVirtualKey(VK_LWIN, 0), KEYEVENTF_KEYUP, 0);
		if(modifiers & MOD_ALT)
			keybd_event(VK_MENU, (BYTE)MapVirtualKey(VK_MENU, 0), KEYEVENTF_KEYUP, 0);
		if(modifiers & MOD_CONTROL)
			keybd_event(VK_CONTROL, (BYTE)MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
		if(modifiers & MOD_SHIFT)
			keybd_event(VK_SHIFT, (BYTE)MapVirtualKey(VK_SHIFT, 0), KEYEVENTF_KEYUP, 0);
		Sleep(ClickWait);
	}
}

UINT SendKeyCheck(UINT KeyCode)
{
	UINT modifiers = 0;

	if(KeyCode == VK_RWIN)
		KeyCode = VK_LWIN;
	if(GetKeyState( VK_SHIFT ) & 0x8000 && KeyCode != VK_SHIFT)
		modifiers |= HOTKEYF_SHIFT;
	if(GetKeyState( VK_CONTROL ) & 0x8000 && KeyCode != VK_CONTROL)
		modifiers |= HOTKEYF_CONTROL;
	if(GetKeyState( VK_MENU ) & 0x8000 && KeyCode != VK_MENU)
		modifiers |= HOTKEYF_ALT;
	if((GetKeyState( VK_LWIN ) & 0x8000 || GetKeyState( VK_RWIN ) & 0x8000) && KeyCode != VK_LWIN)
		modifiers |= HOTKEYF_WIN;

	return MAKEWORD(KeyCode, modifiers);
}

LRESULT CALLBACK KeyBoardHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if(nCode >= 0 && GetFocus() == GetWindow(GetDlgItem(hDlg, IDC_COMBO_SENDKEY), GW_CHILD))
	{
		if(GetKeyState( (int)wParam ) & 0x8000)
			SendMessage(hDlg, WM_KEYBOARD_MSG, wParam, lParam);
		return TRUE;
	}
	return CallNextHookEx(hHook, nCode, wParam, lParam);
}

INT_PTR CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static CONFIGPARAM* configparam;
	static UINT SendKeyCode = 0;
	int ComboKeyTable[] = {
		0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x08, 0x09, 0x0d,
		0x10, 0x11, 0x12, 0x13, 0x14, 0x19, 0x1b, 0x1c, 0x1d,
		0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x2c, 0x2d, 0x2e,
		0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
		0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,
		0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0x5b, 0x5d, 0x5f,
		0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f,
		0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0x7b,
		0x90, 0x91,
		0xa6, 0xa7, 0xa8, 0xa9, 0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
		0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
		0xc0,
		0xdb, 0xdc, 0xdd, -1};
	int i;
	TCHAR KeyName[_MAX_PATH + 1];

	switch(msg)
	{
	case WM_INITDIALOG:
		configparam = (CONFIGPARAM*)lParam;
		if(!configparam->bInitialized)
		{
			configparam->argv.nValue[0] = 0;
			configparam->argv.nValue[1] = 0;
			configparam->argv.nValue[2] = 50;
		}
		hDlg = hwnd;
		hHook = SetWindowsHookEx(WH_KEYBOARD, KeyBoardHookProc, plugin.hDllInstance, 0);
		if(configparam->argv.nValue[0]==1)
			CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO2);
		else if(configparam->argv.nValue[0]==2)
			CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO3);
		else
			CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO1);
		i = 0;
		while(ComboKeyTable[i]!=-1)
		{
			get_keyname(ComboKeyTable[i], KeyName, _MAX_PATH+1);
			SendDlgItemMessage(hwnd, IDC_COMBO_SENDKEY, CB_INSERTSTRING, SendDlgItemMessage(hwnd, IDC_COMBO_SENDKEY, CB_GETCOUNT, 0, 0), (LPARAM)KeyName);
			i++;
		}
		SendDlgItemMessage(hwnd, IDC_COMBO_SENDKEY, CB_SETCURSEL, 0L, 0L);
		SendKeyCode = configparam->argv.nValue[1];
		get_keyname(SendKeyCode, KeyName, _MAX_PATH+1);
		SendMessage(GetWindow(GetDlgItem(hwnd, IDC_COMBO_SENDKEY), GW_CHILD), WM_SETTEXT, 0L, (LPARAM)KeyName);
		SendMessage(GetWindow(GetDlgItem(hwnd, IDC_COMBO_SENDKEY), GW_CHILD), EM_SETSEL, lstrlen(KeyName), lstrlen(KeyName));

		SendDlgItemMessage(hwnd, IDC_SPIN_CLICKWAIT, UDM_SETRANGE, 0, MAKELPARAM(100, 0));
		SendDlgItemMessage(hwnd, IDC_SPIN_CLICKWAIT, UDM_SETPOS, 0, configparam->argv.nValue[2]);
		break;
	case WM_DESTROY:
		UnhookWindowsHookEx(hHook);
		break;
	case WM_NOTIFY:
		switch(((LPNMHDR)lParam)->code)
		{
		case PSN_APPLY:
			if(IsDlgButtonChecked(hwnd, IDC_RADIO1)==BST_CHECKED)
				configparam->argv.nValue[0] = 0;
			if(IsDlgButtonChecked(hwnd, IDC_RADIO2)==BST_CHECKED)
				configparam->argv.nValue[0] = 1;
			if(IsDlgButtonChecked(hwnd, IDC_RADIO3)==BST_CHECKED)
				configparam->argv.nValue[0] = 2;
			configparam->argv.nValue[1] = SendKeyCode;
			configparam->argv.nValue[2] = (int)SendDlgItemMessage(hwnd, IDC_SPIN_CLICKWAIT, UDM_GETPOS, 0, 0);
			break;
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_COMBO_SENDKEY:
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				if(SendDlgItemMessage(hwnd, IDC_COMBO_SENDKEY, CB_GETCURSEL, 0L, 0L) > 0)
				{
					SendKeyCode = SendKeyCheck(ComboKeyTable[SendDlgItemMessage(hwnd, IDC_COMBO_SENDKEY, CB_GETCURSEL, 0L, 0L)]);
					PostMessage(hwnd, WM_COMBO_REFRESH, 0, 0);
				}
				PropSheet_Changed(GetParent(hwnd), hwnd);
			}
			break;
		case IDC_EDIT_CLICKWAIT:
			if(HIWORD(wParam)==EN_CHANGE)
				PropSheet_Changed(GetParent(hwnd), hwnd);
			break;
		case IDC_RADIO1:
		case IDC_RADIO2:
		case IDC_RADIO3:
			PropSheet_Changed(GetParent(hwnd), hwnd);
			break;
		}
		break;

	case WM_COMBO_REFRESH:
		get_keyname(SendKeyCode, KeyName, _MAX_PATH+1);
		SendMessage(GetWindow(GetDlgItem(hwnd, IDC_COMBO_SENDKEY), GW_CHILD), WM_SETTEXT, 0L, (LPARAM)KeyName);
		SendMessage(GetWindow(GetDlgItem(hwnd, IDC_COMBO_SENDKEY), GW_CHILD), EM_SETSEL, lstrlen(KeyName), lstrlen(KeyName));
		PropSheet_Changed(GetParent(hwnd), hwnd);
		break;
	case WM_KEYBOARD_MSG:
		if(!(HIBYTE(SendKeyCode) & HOTKEYF_SHIFT && wParam == VK_SHIFT) &&
			!(HIBYTE(SendKeyCode) & HOTKEYF_CONTROL && wParam == VK_CONTROL) &&
			!(HIBYTE(SendKeyCode) & HOTKEYF_ALT && wParam == VK_MENU) &&
			!(HIBYTE(SendKeyCode) & HOTKEYF_WIN && (wParam == VK_LWIN || wParam == VK_RWIN)))
			SendKeyCode = SendKeyCheck((UINT)wParam);
		PostMessage(hwnd, WM_COMBO_REFRESH, 0, 0);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL Init(void)
{
	return TRUE;
}

void Quit(void)
{
}

void Config(PREFS* prefs, CONFIGPARAM* configparam)
{
	prefs->hInstance = plugin.hDllInstance;
	prefs->id = IDD_DIALOG;
	prefs->DlgProc = DlgProc;
	prefs->lParam = (LPARAM)configparam;
}

void Command(COMMANDPARAM* param)
{
	ExecuteSendKey(param->argv.nValue[0], param->argv.nValue[1], param->argv.nValue[2]);
}

void Description(COMMANDARGV* argv, LPWSTR lpszText, int nLength)
{
	get_keyname(argv->nValue[1], lpszText, nLength);
}
